import requests
import numpy as np

def get_word2vec(tokens):
    """ connects to word2vec service on localhost and retrieves
        embeddings. """

    s = requests.Session()
    r = s.get('http://127.0.0.1:8087/get', params={'tokens': tokens})
    result = r.json()

    for t in result:
        if isinstance(result[t], list):
            # because JSON can only do lists, convert them
            # back to numpy arrays
            result[t] = np.array(result[t])

    return result



if __name__ == "__main__":

    terms = ['apple', 'cherry', 'horse', 'donkey', 'robot', 'C3PO']

    embeddings = get_word2vec(terms)

    for t in terms:
        # print first 10 values of embedding
        print(t, embeddings[t][:4], embeddings[t].shape[0], 'values...')

    # prints pairwise similarities (cosine similarity)
    # between word embeddings
    print 'check similarities'
    for t in terms:
        print t
        for t2 in terms:
            if t2!=t:
                sim = np.dot(embeddings[t], embeddings[t2])
                norm1 = np.linalg.norm(embeddings[t])
                norm2 = np.linalg.norm(embeddings[t2])
                print('  -> %.12s : %.2f percent' %(t2, 100 * sim / norm1 / norm2))

